![Banner image](https://gitea.gildedgames.com/GildedGames/The-Aether/raw/branch/1.12.2/doc/banner.webp)
# The Aether
[![Code license (GNU GPL 3.0)](https://img.shields.io/badge/code%20license-GNU%20GPLv3-green.svg?style=flat-square)](https://www.gnu.org/licenses/gpl-3.0.en.html)
[![Asset license (Unlicensed)](https://img.shields.io/badge/assets%20license-All%20Rights%20Reserved-red.svg?style=flat-square)](https://creativecommons.org/licenses/by-sa/4.0/)

Gilded Games presents the original Aether mod! Up to date for modern Minecraft versions and fully compatible with multiplayer! The Aether is a dimension high in the sky composed of floating islands! Ascend through a Glowstone portal and begin a new survival adventure packed with new ores, mythical creatures and perilous Dungeons! All you need to do is build a Glowstone frame and add water to light the mystical portal, step in and you'll be transported immediately to the luscious hostile paradise known as the Aether! Gilded Games has ensured to keep The Aether as close to the original mod from 2011 as possible, while continuing to work on the sequel, Aether II.

## :heart: Support Gilded Games

[![Patreon pledgers](https://img.shields.io/badge/endpoint.svg?url=https%3A%2F%2Fshieldsio-patreon.herokuapp.com%2FGildedGames&style=flat-square)](https://patreon.com/GildedGames)
[![Discord user count](https://img.shields.io/discord/118816101936267265.svg?logoColor=FFFFFF&logo=discord&color=7289DA&style=flat-square)](https://discord.gg/YgTv7Vg)
[![Twitter followers](https://img.shields.io/twitter/follow/DevAether.svg?logo=twitter&label=twitter&style=flat-square)](https://twitter.com/DevAether)

If you enjoy our work, [please consider making a pledge](https://patreon.com/GildedGames) today to help fund development and gain access to special perks. Every pledge goes directly into the development process and enables us to continue making the Minecraft mods you know and love.

You can also support the Aether project and Gilded Games by telling your friends, joining our Discord server, and sharing our progress and announcements on social media. Every bit helps!

## :package: Download the latest releases
### "Stable" builds
[![CurseForge downloads](https://cf.way2muchnoise.eu/full_255308_downloads.svg)](https://minecraft.curseforge.com/projects/the-aether-mod)
[![CurseForge packs](https://cf.way2muchnoise.eu/packs/full_255308_in_packs.svg)](https://minecraft.curseforge.com/projects/the-aether-mod)

We use Curseforge to publish **stable builds** of the Aether for Minecraft. You can download the latest stable builds from our [official page found here](https://minecraft.curseforge.com/projects/the-aether-mod) without signing up for an account, and even install the Aether for Minecraft using the [Twitch Launcher](https://www.curseforge.com/twitch-client) with built-in integration for Curseforge mods. We recommend using our stable Curseforge releases for most people.

## :bug: Report bugs or other issues
If you're running into bugs or other problems, feel free to open an issue on our [issue tracker](https://gitea.gildedgames.com/GildedGames/The-Aether/issues). When doing so, we ask that you provide the following information:

- The exact version of the Aether you are running, such as `1.7.10-1.1.1`, and the version of Forge you are using, such as `10.13.4.1558`. Please do not state "the latest stable release" or "latest Forge".
- If your issue is a bug or otherwise unexpected behavior, state what you expected to happen.
- If your issue is a crash, attach the latest client or server log and the complete crash report as a file.
- If your issue only occurs with other mods/plugins installed, list the exact mod/plugin versions installed.

Make sure to keep your issue's description clear and concise. Your issue's title should also be easy to digest, giving our developers and reporters a good idea of what's wrong without including too many details. Failure to follow any of the above may result in your issue being closed.

## :wrench: Contribute to the project
Looking to contribute to the project? We ask that you read over our [Contributor's Guide](https://gitea.gildedgames.com/GildedGames/The-Aether/src/branch/1.7.10/CONTRIBUTING.md) for more details and our Contributor License Agreement (CLA) before getting started.

Not sure what to help with? Take a look at our issue tracker for some ideas! [Here's a quick link](https://gitea.gildedgames.com/GildedGames/The-Aether/issues?label_name%5B%5D=Contributions+Welcome) which shows all the currently open issues that we'd love some help on.

## :scroll: License information
If you're wanting to create a gameplay video/review, extension or addon, parody, or any other fan work of your own for the Aether, go for it! We love seeing the content our community creates, and we hope to make it as welcoming as possible for everyone. We ask however that if you are using code or assets from The Aether project that you adhere to the licenses below, and that you please don't advertise using our brand. If you're interested in sponsoring The Aether project or Gilded Games or wish to otherwise use our brand, please [contact us](mailto:support@gildedgames.com).

The source code of The Aether mod for Minecraft 1.7+ is under the [GNU GPL v3](https://www.gnu.org/licenses/gpl-3.0.en.html) license. **All assets of the The Aether for Minecraft 1.7+ (found in the [resources folder](https://gitea.gildedgames.com/GildedGames/The-Aether/src/branch/1.7.10/src/main/resources/assets)) are unlicensed and all rights are reserved to them by Gilded Games.** 

[Wiki contributions](https://gitea.gildedgames.com/GildedGames/Aether-II/wiki) are under the [CC BY-SA 4.0 license](https://creativecommons.org/licenses/by-sa/4.0/) unless otherwise stated.

Previous versions of The Aether are not licensed freely and all rights are reserved to them by Gilded Games. Unlicensed assets are owned and copyrighted by their respective authors and all other rights to them are reserved by Gilded Games. If you would like to use
our unlicensed assets, please [get in contact with us](mailto:support@gildedgames.com) for details.

## :star2: Special mentions
### :speech_balloon: Translations
The Aether project makes use of crowd sourced translations. The Aether is available in these languages thanks to the following contributors:

- Chinese * (zh_CN, zh_TW) - Translations by: ETStareak, y830705
- Dutch * (nl_NL) - Translations by: Critical
- French * (fr_FR) - Translations by: lololoustau and Beethov46
- German * (de_DE) - Translations by: DarkBread
- Italian * (it_IT)
- Korean * (ko_KR) - Translations by: minejango2
- Polish * (pl_PL) - Translations by: DarkKnightComes
- Romanian * (ro_RO)
- Russian * (ru_RU) - Translations by: LeyxorCheysen, andreyalex1236, LunarP1, and zombi1944
- Spanish * (es_MX) - Translations by: Aer-ink
- Swedish * (sv_SE) - Translations by: magicus
- Thai * (th_TH)
- Ukranian * (uk_UK)

_\* Indicates only partial language support._

The above list is incomplete, and as such, if your name is missing from it, please contact us. **You can help translate The Aether Mod to additional languages by joining our team of avid translators [here](https://aether.oneskyapp.com/collaboration/project?id=158541).**
