package com.gildedgames.the_aether.client.models.entities;

import net.minecraft.client.model.ModelQuadruped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;

import com.gildedgames.the_aether.entities.passive.EntitySheepuff;

public class SheepuffedModel extends ModelQuadruped {

	private float headRotationAngleX;

	public SheepuffedModel() {
		super(12, 0.0F);

		this.head = new ModelRenderer(this, 0, 0);
		this.head.addBox(-3.0F, -4.0F, -4.0F, 6, 6, 6, 0.6F);
		this.head.setRotationPoint(0.0F, 6.0F, -8.0F);

		this.body = new ModelRenderer(this, 28, 8);
		this.body.addBox(-4.0F, -8.0F, -7.0F, 8, 16, 6, 3.75F);
		this.body.setRotationPoint(0.0F, 5.0F, 2.0F);

		this.leg1 = new ModelRenderer(this, 0, 16);
		this.leg1.addBox(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
		this.leg1.setRotationPoint(-3.0F, 12.0F, 7.0F);

		this.leg2 = new ModelRenderer(this, 0, 16);
		this.leg2.addBox(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
		this.leg2.setRotationPoint(3.0F, 12.0F, 7.0F);

		this.leg3 = new ModelRenderer(this, 0, 16);
		this.leg3.addBox(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
		this.leg3.setRotationPoint(-3.0F, 12.0F, -5.0F);

		this.leg4 = new ModelRenderer(this, 0, 16);
		this.leg4.addBox(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
		this.leg4.setRotationPoint(3.0F, 12.0F, -5.0F);
	}

	@Override
	public void setLivingAnimations(EntityLivingBase entitylivingbaseIn, float limbSwing, float prevLimbSwing, float partialTickTime) {
		super.setLivingAnimations(entitylivingbaseIn, limbSwing, prevLimbSwing, partialTickTime);

		this.head.rotationPointY = 6.0F + ((EntitySheepuff) entitylivingbaseIn).getHeadRotationPointY(partialTickTime) * 9.0F;
		this.headRotationAngleX = ((EntitySheepuff) entitylivingbaseIn).getHeadRotationAngleX(partialTickTime);
	}

	@Override
	public void setRotationAngles(float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scaleFactor, Entity entityIn) {
		super.setRotationAngles(limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scaleFactor, entityIn);

		this.head.rotateAngleX = this.headRotationAngleX;
	}

}